<?php
/*
Plugin Name: Hello Claudia
Plugin URI: http://dogmap.jp/
Description: Windows Azure Japanese official character "Claudia Madobe" is plugin to speak a message on a dashboard.
Author: wokamoto
Author URI: http://dogmap.jp/
Version: 0.4.0

License:
 Released under the GPL license
  http://www.gnu.org/copyleft/gpl.html
  Copyright 2011 wokamoto (email : wokamoto1973@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 Claudia
  Copyright 2011 Microsoft Corp. All Rights Reserved.
  http://msdn.microsoft.com/ja-jp/windowsazure/hh298798

 FlexPlayer v0.1.0
  Copyright (c) 2009 galara
  http://www.wktklabs.com/flexplayer/
  Date: 2009-06-03
  Dual licensed under the MIT licenses.
*/

class HelloClaudia{
	private $textdomain = 'hello-claudia';
	private $image_url = array();
	private $voice_url = array();
	private $voice = array();

	const SHORTCODE_HANDLER = 'claudia';

	/**********************************************************
	* Constructor
	***********************************************************/
	function __construct() {
		$this->init();
		if (is_admin()) {
			add_action( 'admin_init', array(&$this,'add_scripts') );
			add_action( 'admin_head-index.php', array(&$this, 'add_styles') );
			add_action( 'wp_dashboard_setup', array(&$this, 'dashboard_widgets') );
		} else {
			add_action( 'wp_print_scripts', array(&$this,'add_scripts') );
			add_action( 'wp_head', array(&$this, 'add_styles') );
			add_shortcode( self::SHORTCODE_HANDLER, array(&$this, 'shortcode_handler') );
		}
	}

	// init
	private function init() {
		$image = plugin_dir_url( __FILE__ ) . 'images/';
		$this->image_url = array(
			'fukidashi_top' => $image . 'back-fukidashi-top.png',
			'fukidashi_center'=> $image . 'back-fukidashi-center.png',
			'fukidashi_bottom' => $image . 'back-fukidashi-bottom.png',
			'claudia' => $image . ($this->is_azure() ? 'back-claudia-azure.png' : 'back-claudia-right.png'),
			);
		$media = plugin_dir_url( __FILE__ ) . 'media/';
		$this->voice_url = array(
			 1 => $media . '01sahajimeru.m4a',
			 3 => $media . '03syuuryou.m4a' ,
			 4 => $media . '04oujougiwa.m4a' ,
			 5 => $media . '05okazure.m4a' ,
			 6 => $media . '06windowsazureha.m4a' ,
			 7 => $media . '07azurenisite.m4a' ,
			 8 => $media . '08windowsazure.m4a' ,
			 9 => $media . '09cloudwoyoro.m4a' ,
			10 => $media . '10microsoft.m4a' ,
			11 => $media . '11mangadewakaru.m4a' ,
			12 => $media . '12sorenara.m4a' ,
			13 => $media . '13blue.m4a' ,
			14 => $media . '14azurenojituryoku.m4a' ,
			16 => $media . '16finiiish.m4a' ,
			17 => $media . '17goo.m4a' ,
			18 => $media . '18par.m4a' ,
			19 => $media . '19choki.m4a' ,
			20 => $media . '20aikogoo.m4a' ,
			21 => $media . '21aikopar.m4a',
			22 => $media . '22aikochoki.m4a' ,
			27 => $media . '27goodmorningazuresky.m4a' ,
			28 => $media . '28denwa.m4a' ,
			29 => $media . '29mail.m4a' ,
			30 => $media . '30start.m4a' ,
			31 => $media . '31deploykaishi.m4a' ,
			32 => $media . '32deploykanryo.m4a' ,
			33 => $media . '33build.m4a' ,
			34 => $media . '34sippai.m4a' ,
			35 => $media . '35daiseikou.m4a' ,
			36 => $media . '36ei.m4a' ,
			37 => $media . '37ah.m4a' ,
			38 => $media . '38otsukare.m4a' ,
			39 => $media . '39kokogapoint.m4a' ,
			40 => $media . '40chui.m4a' ,
			);
		$this->voice = array(
			 1 => __('さぁ、始めるわヨ', $this->textdomain) ,
			 3 => __('終了～', $this->textdomain) ,
			 4 => __('往生際が悪いわヨ', $this->textdomain) ,
			 5 => __('OK, Azure 今日もいい子ネ', $this->textdomain) ,
			 6 => __('Windows Azure はわたしの、最高の友達', $this->textdomain) ,
			 7 => __('Azure にして後悔なんて、あるわけない', $this->textdomain) ,
			 8 => __('Windows Azure', $this->textdomain) ,
			 9 => __('クラウドをよろしくネ', $this->textdomain) ,
			10 => __('マイクロソフト', $this->textdomain) ,
			11 => __('マンガでわかる Windows Azure プラットフォーム', $this->textdomain) ,
			12 => __('それなら Windows Azure にすればいいじゃない', $this->textdomain) ,
			13 => __('ブルースクリーンみたいな顔色ネ', $this->textdomain) ,
			14 => __('Azure の実力はまだまだこんなモノじゃないワ!', $this->textdomain) ,
			16 => __('Finiiiiiish', $this->textdomain) ,
			17 => __('じゃんけん、グー', $this->textdomain) ,
			18 => __('じゃんけん、パー', $this->textdomain) ,
			19 => __('じゃんけん、チョキ', $this->textdomain) ,
			20 => __('あいこで、グー', $this->textdomain) ,
			21 => __('あいこで、パー', $this->textdomain) ,
			22 => __('あいこで、チョキ', $this->textdomain) ,
			27 => __('Good Morning Azure Sky!', $this->textdomain) ,
			28 => __('電話が鳴ってる', $this->textdomain) ,
			29 => __('メールが来たっ', $this->textdomain) ,
			30 => __('スタート!', $this->textdomain) ,
			31 => __('デプロイ開始!', $this->textdomain) ,
			32 => __('デプロイ完了!', $this->textdomain) ,
			33 => __('ビルド完了!', $this->textdomain) ,
			34 => __('失敗しちゃった！', $this->textdomain) ,
			35 => __('大成功!', $this->textdomain) ,
			36 => __('エイッ!', $this->textdomain) ,
			37 => __('きゃっ', $this->textdomain) ,
			38 => __('お疲れ様♪', $this->textdomain) ,
			39 => __('ここがポイント！', $this->textdomain) ,
			40 => __('注意してネ♪', $this->textdomain) ,
			);
	}

	/**********************************************************
	* claudia !
	***********************************************************/
	private function claudia($msg, $voice_url = ''){
		$copyright = '<p style="padding:0;"><small>&copy; 2011 Microsoft Corp.' . (is_admin() ? '<br />' : ' ') . 'All Rights Reserved.</small></p>';
		$retval = '';
		if ( !empty($voice_url) ) {
			$retval .= $this->flexplayer();
			$voice = ' onclick="playStart(' . "'" . esc_url($voice_url) . "'" . ')"';
		}
		$retval .= '<div class="claudia2">';
		$retval .= '<div class="claudia3"> </div>';
		$retval .= '<div class="claudia4">' . $msg . '</div>';
		$retval .= '</div>';
		$retval .= '<div class="claudia"' . $voice . '>&nbsp;</div>';
		$retval .= '<div class="claudia5">' . $copyright . '</div>';
		if ( is_admin() ) {
			$retval .= '<div style="clear:both;"> </div>';
		}
		return $retval;
	}

	// init flaxplayer
	private function flexplayer(){
		static $init_flexplayer = TRUE;
		$retval = '';
		if ( $init_flexplayer ) {
			$plugin_dir_url = plugin_dir_url( __FILE__ );
			$retval  = '<script src="' . $plugin_dir_url . 'flexplayer/jquery.flexplayer.min.js" type="text/javascript"></script>' . "\n";
			$retval .= '<script type="text/javascript">' . "\n";
			$retval .= '// <![CDATA[' . "\n";
			$retval .= 'var player;' . "\n";
			$retval .= 'jQuery(function() {';
			$retval .= 'player = new jQuery(".claudia").flexplayer({ swfPath : "' . $plugin_dir_url . 'flexplayer/flexplayer.swf" });}';
			$retval .= ');' . "\n";
			$retval .= 'function playStart(media_url){';
			$retval .= 'player.play({type: "m4a", path: media_url, volume: 100});';
			$retval .= '}' . "\n";
			$retval .= '// ]]>' . "\n";
			$retval .= '</script>' . "\n";
			$init_flexplayer = FALSE;
		}
		return $retval;
	}

	// a last contribution day.
	private function get_last_update(){
		global $wpdb;
		$current_user = wp_get_current_user();
		$date = $wpdb->get_results(
			$wpdb->prepare("
			SELECT MAX(post_date) as last
			FROM $wpdb->posts
			WHERE post_status = 'publish'
			AND post_author = %d
			", (int)$current_user->ID
			)
		);
		return $date[0]->last;
	}
	
	// is azure ?
	private function is_azure(){
		return function_exists( 'azure_getconfig' );
	}

	/**********************************************************
	* dashboard widgets
	***********************************************************/
	public function dashboard_widgets() {
		wp_add_dashboard_widget( 'claudia_dashboard', __('クラウディア窓辺', $this->textdomain), array(&$this,'claudia_dashboard') );
	}

	/**********************************************************
	* add scripts
	***********************************************************/
	public function add_scripts() {
		wp_enqueue_script( 'jquery' );
	}

	/**********************************************************
	* add styles
	***********************************************************/
	public function add_styles(){
?>
<style type="text/css" charset="utf-8">
.claudia, .claudia2, .claudia3, .claudia4, .claudia5 {
	padding: 0;
}
.claudia2, .claudia3, .claudia4 {
	max-width: 440px;
}
.claudia {
	margin: -5px 0 0 0;
	background: url( <?php echo esc_url( $this->image_url['claudia'] ); ?> ) no-repeat right top;
	background-size: contain;
	height: 246px;
	float: left;
	width: 30%;
	max-width: 134px;
}
.claudia2 {
	width: 70%;
	margin: 20px 0 0;
	background: url( <?php echo esc_url( $this->image_url['fukidashi_center'] ); ?> ) repeat-y left top;
	background-size: contain;
	float: left;
}
.claudia3 {
	margin: -20px 0 0;
	height: 100px;
	background: url( <?php echo esc_url( $this->image_url['fukidashi_top'] ); ?> ) no-repeat left top;
	background-size: contain;
}
.claudia4 {
	margin: -100px 0 -20px;
	padding: 5% 15% 5% 10%;
	line-height: 160%;
	background: url( <?php echo esc_url( $this->image_url['fukidashi_bottom'] ); ?> ) no-repeat left bottom;
	background-size: contain;
	min-height: 90px;
}
.claudia5 {
	margin: 0;
	text-align:right;
	<?php echo (is_admin() ? 'float: left;' : 'clear: both;') . "\n"; ?>
}
<?php
		if (is_admin()) {
?>
#claudia_dashboard .inside {height:300px}
.claudia6, .claudia7, .claudia8 {padding: 0;}
.claudia6 {margin: 3px 0 12px;}
.claudia7 {margin: 8px 0 12px;}
.claudia8 {margin: 10px 0 3px;}
<?php
		}
?>

</style>
<?php
	}

	/**********************************************************
	* "claudia" widget of the dashboard.
	***********************************************************/
	public function claudia_dashboard(){
		global $current_user;

		$msg = '';

		// claudia6
		$hour = (int)date_i18n("H");
		if ($hour > 17) {
			$msg_1 = 38;
		} elseif ($hour > 10) {
			$msg_1 = 1;
		} elseif ($hour > 5) {
			$msg_1 = 27;
		} elseif ($hour < 3) {
			$msg_1 = 4;
		} else {
			$msg_1 = 13;
		}
		if ($this->is_azure()) {
			$rand = (int)rand(1,100);
			if ($rand > 80) {
				$msg_2 = 6;
			} elseif ($rand > 60) {
				$msg_2 = 7;
			} elseif ($rand > 40) {
				$msg_2 = 9;
			} elseif ($rand > 20) {
				$msg_2 = 5;
			} else {
				$msg_2 = 14;
			}
		} else {
			$msg_2 = '12';
		}
		$voice = array($this->voice_url[$msg_1], $this->voice_url[$msg_2]);
		$msg .= '<p class="claudia6">';
		$msg .= sprintf(
			__('<big><strong>%1$s</strong></big><br style="margin-bottom:.5em;"/><big>%2$s</big><br />%3$s', $this->textdomain),
			$current_user->display_name,
			$this->voice[$msg_1],
			$this->voice[$msg_2]
			);
		$msg .= '</p>';

		// claudia7
		$youbi = array(
			__('(日)', $this->textdomain),
			__('(月)', $this->textdomain),
			__('(火)', $this->textdomain),
			__('(水)', $this->textdomain),
			__('(木)', $this->textdomain),
			__('(金)', $this->textdomain),
			__('(土)', $this->textdomain),
			);
		$nowtime = date_i18n('Y年n月j日') . $youbi[(int)date_i18n('w')];
		$nowtime .= '&nbsp;' . date_i18n('G時i分');
		$msg .= '<p class="claudia7">';
		$msg .= sprintf(
			__('<big>%s</big>&nbsp;だヨ。', $this->textdomain),
			$nowtime
			);
		$msg .= '</p>';

		// claudia6
		$last_update = $this->get_last_update();
		$msg .= '<p class="claudia6">';
		$msg .= sprintf(
			__('最後に記事を投稿したのは、<br /><big>%s</big>', $this->textdomain),
			mysql2date( 'Y年n月j日', $last_update )
			);
		$msg .= '</p>';

		$lastdate = mysql2date( 'YmdHi', $last_update );
		$now = date_i18n('YmdHi');
		$lastdatenow = (strtotime($now)-strtotime($lastdate))/(3600*24);
		$lasttimenow = (strtotime($now)-strtotime($lastdate))/(3600);	
		if ($lastdatenow < 1) {
			$msg_3 = sprintf(
				__('%d 時間', $this->textdomain),
				floor($lasttimenow)
				);
		} elseif ($lastdatenow < 365) {
			$msg_3 = sprintf(
				__('%1$d 日と %2$d 時間', $this->textdomain),
				floor($lastdatenow),
				floor($lasttimenow - (intval($lastdatenow) * 24))
				);
		} else {
			$msg_3 = __('1年以上', $this->textdomain);
		}
		$msg .= '<p class="claudia6">';
		$msg .= sprintf(
			__('最後に記事を投稿してから、<br /><big>%s</big>&nbsp;たったワ。', $this->textdomain). '<br />',
			$msg_3
			);
		$msg .= '</p>';

		// claudia8
		if ($lastdatenow > 365) {
			$msg_6 = __('心機一転！<br />1年以上ぶりでもいいじゃない！<br />思い切って記事を書いてみよう！', $this->textdomain);
		} elseif ($lastdatenow > 30) {
			$msg_6 = __('久しぶりに記事を書いてみよう！<br />思い切って書き始めれば、<br />記事を書くペースもつかめるヨ！', $this->textdomain);
		} elseif ($lastdatenow > 7) {
			$msg_6 = __('1週間以上、空いちゃったネ。<br />みんな待ってるヨ！<br />また記事を書いてみよう！', $this->textdomain);
		} else {
			$msg_6 = __('いいペースだネ！<br />今日も記事を書いてみよう！<br />&nbsp;', $this->textdomain);
		}
		$msg .= '<p class="claudia8">';
		$msg .= sprintf(
			__('<big>%s</big>', $this->textdomain),
			$msg_6
			);
		$msg .= '</p>';

		echo $this->claudia($msg, $voice[0]);
	}

	/**********************************************************
	* shortcode handler
	***********************************************************/
	public function shortcode_handler($atts, $content = '') {
		extract( shortcode_atts( array(
			'voice'       => '' ,
			), $atts ) );

		$voice = !empty($voice) ? intval($voice) : '';
		$voice_url = ''; 
 		if (!empty($voice) && isset($this->voice[$voice])) {
 			$content .= $this->voice[$voice];
 			$voice_url = $this->voice_url[$voice];
 		}
 
		return $this->claudia($content, $voice_url);
	}
}
new HelloClaudia();
